function invA = GaussJordan(A)
  n = length(A);
  I = eye(n);
  for k = 1:n
    M = choixpivotbis(A,I,k);
    A = M(:,1:n);
    I = M(:,n+1:2*n);
    for i = 1:k-1
      mu = A(i,k)/A(k,k);
      for j = 1:n
        A(i,j) = A(i,j) - mu * A(k,j);
        I(i,j) = I(i,j) - mu * I(k,j);
      endfor
    endfor
    for i = k+1:n
      mu = A(i,k)/A(k,k);
      for j = 1:n
        A(i,j) = A(i,j) - mu * A(k,j);
        I(i,j) = I(i,j) - mu * I(k,j);
      endfor
    endfor
  endfor
  for i=1:n
    for j=1:n
      I(i,j) = I(i,j)/A(i,i);
    endfor
  endfor
  invA = I;
endfunction
