function B = cholesky(A)
  n = length(A);
  B = zeros(n);
  for j = 1:n
    s = 0;
    for k = 1:j-1
      s = s + B(j,k)^2;
    endfor
    B(j,j) = sqrt(A(j,j)-s);
    for i = j+1:n
      s = 0;
      for k = 1:j-1
        s = s + B(i,k)*B(j,k);
      endfor
      B(i,j) = (A(i,j) - s)/B(j,j);
    endfor
  endfor
endfunction
