close all
clear all

f=@(t,y) (-y + t + 1);

fprime=@(y)(-1);

%La solution exacte de y'=-y+t+1
g=@(t) (exp(-t)+t);

te=0:0.01:1;

ye=g(te);

t0 = 0;
y0 = 1;
t_max = 1;

n = 10:20:50;

for i=1:length(n)
  [t1,y1]=euler_forward(f,t0,y0,t_max,n(i));
  [t2,y2]=euler_modified(f,t0,y0,t_max,n(i));
  [t3,y3]=RK4(f,t0,y0,t_max,n(i));
  [t4,y4]=AB4(f,t0,y0,t_max,n(i));
  figure(i)
  plot(te,ye,'b',t1,y1,'g.',t2,y2,'k*',t3,y3,'mo', t4,y4,'r+')
  xlabel('t')
  ylabel('y')
  legend('Analytical solution','Forward Euler Method','Modified Euler Method', 'RK4 Method', 'AB4 Method', 'Location','northwest')
  axis([0 1 1  1.4])
  title(sprintf('Solutions for n=%d', n(i)))
endfor
